package com.rjconsultores.ventaboletos.dao.hibernate;

import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Order;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

import com.rjconsultores.ventaboletos.dao.InstiFinanceiraDAO;
import com.rjconsultores.ventaboletos.entidad.EmpresaContaBancaria;
import com.rjconsultores.ventaboletos.entidad.InstiFinanceira;

@Repository("ptovtaBancoDAO")
@SuppressWarnings("unchecked")
public class InstiFinanceiraHibernateDAO extends GenericHibernateDAO<InstiFinanceira, Integer>
	implements InstiFinanceiraDAO {

    @Autowired
    public InstiFinanceiraHibernateDAO(
            @Qualifier("sessionFactory") SessionFactory factory) {
        setSessionFactory(factory);
    }
    
	@Override
    public List<InstiFinanceira> obtenerTodos() {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));
        c.addOrder(Order.asc("nome"));        
        return c.list();
    }

    public List<InstiFinanceira> buscar(String nome) {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));
        c.add(Restrictions.eq("nome", nome));       
        return c.list();
    }

	@Override
	public List<EmpresaContaBancaria> buscarContasBancariasPorIdEmpresa(Integer empresaId) {
        
		Criteria c = getSession().createCriteria(EmpresaContaBancaria.class);
        c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));
        c.add(Restrictions.eq("empresa.empresaId", empresaId));
        
        List<EmpresaContaBancaria> empresasContaBancarias =  (List<EmpresaContaBancaria>) c.list();
        return empresasContaBancarias;
	}

   
}

